#include <stdio.h> 
#include <fcntl.h> 
#include <unistd.h>
#include <sys/time.h>
#include "ccusb.h"

#define LOOP 100
#define SIZE 16 * 1024 //word

unsigned int buf[SIZE];

void print_time(struct timeval tp1, struct timeval tp2, int siz){
  long sec, usec;
  float fsec, ftime, speed;

  sec = (tp2.tv_sec) - (tp1.tv_sec);
  usec = (tp2.tv_usec) - (tp1.tv_usec);

  fsec = (float)sec + (float)usec/(float)1000000.;
  ftime = ((float)fsec)/((float)LOOP)*(float)1000000.;
  speed = (float)siz * (float)LOOP/fsec/(float)1000.0;

  printf("%d Byte  %7.2f usec  %7.4f KByte/s\n", siz, ftime, speed);
  //printf("%d %7.2f %7.2f\n", siz, ftime, speed);

}


int main()
{
  int crate=0, ret, retlen, i, siz;
  struct timeval tp1, tp2;

  ret = camopen(crate);
  if(ret < 0)
	  printf("CAMAC Open ERROR\n");
  gettimeofday(&tp1, NULL);
 
  for(i = 0; i < LOOP; i++)
    retlen = cdma(crate, 2, 1, 0, BLOCK_QIGNO, buf, SIZE);

  gettimeofday(&tp2, NULL);

  printf("retlen = %d\n", retlen);

  siz = SIZE * 3;
  print_time(tp1, tp2, siz);
  camcls(crate);
  return 0;
}
