#include <stdio.h>
#include <fcntl.h> 
#include <unistd.h>
#include <stdlib.h>
#include <sys/ioctl.h>
#include "ccusb.h"

//#define TEST

int camopen(int crate);
int camcls(int crate);
int cgenz(int crate);
int cgenc(int crate);
int cseti(int crate);
int cremi(int crate);
int clamstat (int crate);
int camac(int c, int n, int a, int f, int *dat, int *q, int *x);
int camacw(int c, int n, int a, int f, int *dat, int *q, int *x);
int cdma(int c, int n, int a, int f, int mode, int *buf, int len);
int cdmaw(int c, int n, int a, int f, int mode, short *buf, int len);

struct cam_crate {
	unsigned int crate;
	struct camac_single cam_sing;
	struct camac_block  cam_blk;
};

static struct cam_crate cam_crate[8];

static int fd[8] = {-1, -1, -1, -1, -1, -1, -1, -1};


int camopen(int crate)
{
	int ret;

	switch (crate) {

	case 0:
	{
		ret = open("/dev/usb/ccusb00", O_RDWR);
		if(ret < 0)
			return ret;
		else 
			fd[0] = ret;
		break;
	}
	case 1:
	{
		
		ret = open("/dev/usb/ccusb01", O_RDWR);
		if(ret < 0)
			return ret;
		else 
			fd[1] = ret;		
		break;
	}
	case 2:
	{
		ret = open("/dev/usb/ccusb02", O_RDWR);
		if(ret < 0)
			return ret;
		else 
			fd[2] = ret;

		break;
	}
	case 3:
	{
		ret = open("/dev/usb/ccusb03", O_RDWR);
		if(ret < 0)
			return ret;
		else 
			fd[3] = ret;		
		break;
	}
	case 4:
	{
		ret = open("/dev/usb/ccusb04", O_RDWR);
		if(ret < 0)
			return ret;
		else 
			fd[4] = ret;
		break;
	}
	case 5:
	{
		ret = open("/dev/usb/ccusb05", O_RDWR);
		if(ret < 0)
			return ret;
		else 
			fd[5] = ret;
		break;
	}
	case 6:
	{
		ret = open("/dev/usb/ccusb06", O_RDWR);
		if(ret < 0)
			return ret;
		else 
			fd[6] = ret;
		break;
	}
	case 7:
	{
		ret = open("/dev/usb/ccusb07", O_RDWR);
		if(ret < 0)
			return ret;
		else 
			fd[7] = ret;
		break;
	}

	default:
		printf("camopen ERROR: Please set Crate# 0 to 7\n");
		printf("You have set a wrong Crate#: Crate# = %d\n", crate);
		return -1;

	}
	return 0;
}

int camcls(crate)
{
	switch (crate) {

	case 0:
	{
		close( fd[0] );
		break;
	}
	case 1:
	{
		close( fd[1] );
		break;
	}
	case 2:
	{
		close( fd[2] );
		break;
	}
	case 3:
	{
		close( fd[3] );
		break;
	}
	case 4:
	{
		close( fd[4] );
		break;
	}
	case 5:
	{
		close( fd[5] );
		break;
	}
	case 6:
	{
		close( fd[6] );
		break;
	}
	case 7:
	{
		close( fd[7] );
		break;
	}
	default:
		printf("camcls ERROR: Please set Crate# 0 to 7\n");
		printf("You have set a wrong Crate#: Crate# = %d\n", crate);
		return -1;
	}
	return 0;
}

int cgenz(int crate)
{
	int ret;

	ret = ioctl(fd[crate], CAM_INIT, NULL);
	return ret;
}

int cgenc(int crate)
{
	int ret;

	ret = ioctl(fd[crate], CAM_CLEAR, NULL);
	return ret;
}

int cseti(int crate)
{
	int ret;

	ret = ioctl(fd[crate], CAM_SETI, NULL);
	return ret;
}

int cremi(int crate)
{
	int ret;

	ret = ioctl(fd[crate], CAM_CLRI, NULL);
	return ret;
}

int clamstat(int crate)
{
	int ret;

	ret = ioctl(fd[crate], CAM_READLAM, NULL);
	return ret;
}

int camac(int c, int n, int a, int f, int *dat, int *q, int *x)
{
	int ret;

	cam_crate[c].cam_sing.naf[0] = n;
	cam_crate[c].cam_sing.naf[1] = a;
	cam_crate[c].cam_sing.naf[2] = f;

	if(f > 15 && f < 24 )
		cam_crate[c].cam_sing.data = *dat;

	ret = ioctl(fd[c], CAM_LONG, &cam_crate[c].cam_sing);

	if( f >= 0 && f < 8 )
		*dat = cam_crate[c].cam_sing.data;
	*x = (cam_crate[c].cam_sing.qx & 0x02) >> 1;
	*q = cam_crate[c].cam_sing.qx & 0x01;

	return ret;
}

int camacw(int c, int n, int a, int f, int *dat, int *q, int *x)
{
	int ret;

	cam_crate[c].cam_sing.naf[0] = n;
	cam_crate[c].cam_sing.naf[1] = a;
	cam_crate[c].cam_sing.naf[2] = f;

	if(f > 15 && f < 24 )
		cam_crate[c].cam_sing.data = *dat;

	ret = ioctl(fd[c], CAM_WORD, &cam_crate[c].cam_sing);

	if( f >= 0 && f < 8 )
		*dat = cam_crate[c].cam_sing.data;
	*x = (cam_crate[c].cam_sing.qx & 0x02) >> 1;
	*q = cam_crate[c].cam_sing.qx & 0x01;

	return ret;
}

int cdma(int c, int n, int a, int f, int mode, int *buf, int ch)
{
	int i, ret;
	unsigned char *blkdatc;
	unsigned char *cptr;
	
	blkdatc = (unsigned char * )malloc( ch * CAMAC_LWORD );
	if(blkdatc == NULL)
		return -1;

	cam_crate[c].cam_blk.naf[0] = n;
	cam_crate[c].cam_blk.naf[1] = a;
	cam_crate[c].cam_blk.naf[2] = f;
	cam_crate[c].cam_blk.mode   = mode;
	cam_crate[c].cam_blk.ch     = ch;
	cam_crate[c].cam_blk.data   = blkdatc;

	ret = ioctl(fd[c], CAM_BLKL, &cam_crate[c].cam_blk);

	cptr = blkdatc;
	for(i = 0; i < ch; i++) {
		buf[i]= (* (unsigned int *)cptr ) & 0x00ffffff;
		cptr = cptr + 3;
	}
	return cam_crate[c].cam_blk.retlen;
}

int cdmaw(int c, int n, int a, int f, int mode, short *buf, int ch)
{
	int ret;
	unsigned char *blkdatc;
	
	blkdatc = (unsigned char * )malloc( ch * CAMAC_LWORD );
	if(blkdatc == NULL)
		return -1;

	cam_crate[c].cam_blk.naf[0] = n;
	cam_crate[c].cam_blk.naf[1] = a;
	cam_crate[c].cam_blk.naf[2] = f;
	cam_crate[c].cam_blk.mode   = mode;
	cam_crate[c].cam_blk.ch     = ch;
	cam_crate[c].cam_blk.data   = buf;

	ret = ioctl(fd[c], CAM_BLKW, &cam_crate[c].cam_blk);

	return cam_crate[c].cam_blk.retlen;
}

#ifdef TEST
int main()
{
	int i, ret;
	int crate = 0;
	int dat, q, x;
	int retlen, buf[50];
	short bufs[50];

	camopen(crate);
	cgenz(crate);
	cgenc(crate);
	cseti(crate);
	cremi(crate);

	ret = camac(crate, 2, 1, 0, &dat, &q, &x);
	if(ret < 0)
		printf("ret = %d\n", ret);
	printf("dat = 0x%x(%d)\n", dat, dat);
	printf("q = %d   x = %d\n", q, x);

	ret = camacw(crate, 2, 1, 0, &dat, &q, &x);
	if(ret < 0)
		printf("ret = %d\n", ret);
	printf("dat = 0x%x(%d)\n", dat, dat);
	printf("q = %d   x = %d\n", q, x);

	retlen = cdma(crate, 2, 1, 0, BLOCK_QIGNO, buf, 10);
	printf("retlen = %d\n", retlen);
	for(i=0; i< 10; i++)
		printf("buf[%d]=%d(0x%x)\n", i, buf[i], buf[i]);

	retlen = cdmaw(crate, 2, 1, 0, BLOCK_QIGNO, bufs, 10);
	printf("retlen = %d\n", retlen);
	for(i=0; i< 10; i++)
		printf("bufs[%d]=%d(0x%x)\n", i, bufs[i], bufs[i]);

	camcls(crate);

	return 0;
}
#endif
