#include <stdio.h> 
#include <fcntl.h> 
#include <unistd.h>
#include <sys/time.h>
#include "ccusb.h"

#define LOOP 100

void print_time(struct timeval tp1, struct timeval tp2, int siz);

int main()
{
  int crate=0, dat, q, x, ret, i, siz;

  struct timeval tp1, tp2;

  ret = camopen(crate);
  if(ret < 0)
	  printf("CAMAC Open ERROR\n");
  gettimeofday(&tp1, NULL);
 
  for(i = 0; i < LOOP; i++)
	  ret = camac(crate, 2, 1, 0, &dat, &q, &x);

  gettimeofday(&tp2, NULL);

  siz = 3;
  print_time(tp1, tp2, siz);

  camcls(crate);
  return 0;
}


void print_time(struct timeval tp1, struct timeval tp2, int siz){
  long sec, usec;
  float fsec, ftime, speed;

  sec = (tp2.tv_sec) - (tp1.tv_sec);
  usec = (tp2.tv_usec) - (tp1.tv_usec);

  fsec = (float)sec + (float)usec/(float)1000000.;
  ftime = ((float)fsec)/((float)LOOP)*(float)1000000.;
  speed = (float)siz * (float)LOOP/fsec/(float)1000.0;

  printf("%d Byte  %7.2f usec  %7.4f KByte/s\n", siz, ftime, speed);
  //printf("%d %7.2f %7.2f\n", siz, ftime, speed);

}
