#include <linux/ioctl.h>
enum usb_ctrl_com {
	SINGLE_NOSTAT = 0x00,
	SINGLE_STAT = 0x01,
	BLOCK_QSTOP = 0x02,
	BLOCK_QIGNO = 0x03,
	BLOCK_QREPE = 0x04,
	BLOCK_ASCAN = 0x05,
	INITIALIZE  = 0x06,
	CLEAR       = 0x07,
	SET_INH     = 0x08,
	CLR_INH     = 0x09,
	SET_LAM     = 0x0A,
	CLR_LAM     = 0x0B,
	READ_STAT   = 0x0C,
	READ_LAM    = 0x0D,
	READ_ID     = 0x0E,
	RESERVE     = 0x0F,
	CAM_LBIT    = 0x10
};

enum byte_size_of_camac_word {
	CAMAC_WORD  = 2,
	CAMAC_LWORD = 3
};

enum usb_tras_status_bit {
	ERROR   = 0x80,
	OFFLINE = 0x40,
	TIMEOUT = 0x20,
	ERRORS  = ERROR | OFFLINE | TIMEOUT
};
/*--------------------------------------------------------------------------*/
/*  IOCTL COMMAND                                                           */
/*--------------------------------------------------------------------------*/
#define TOYO_IOC_MAGIC 'D'
#define CAM_WORD    _IOWR(TOYO_IOC_MAGIC, 0x00, 0x02)
#define CAM_LONG    _IOWR(TOYO_IOC_MAGIC, 0x01, 0x04)
#define CAM_BLKW    _IOWR(TOYO_IOC_MAGIC, 0x02, MAX_TRANS_BYTES)
#define CAM_BLKL    _IOWR(TOYO_IOC_MAGIC, 0x03, MAX_TRANS_BYTES)
#define CAM_INIT    _IOWR(TOYO_IOC_MAGIC, INITIALIZE,  0x01)
#define CAM_CLEAR   _IOWR(TOYO_IOC_MAGIC, CLEAR, 0x01)
#define CAM_SETI    _IOWR(TOYO_IOC_MAGIC, SET_INH, 0x01)
#define CAM_CLRI    _IOWR(TOYO_IOC_MAGIC, CLR_INH, 0x01)
#define CAM_SETLAM  _IOWR(TOYO_IOC_MAGIC, SET_LAM, 0x01)
#define CAM_CLRLAM  _IOWR(TOYO_IOC_MAGIC, CLR_LAM, 0x01)
#define CAM_STATUS  _IOWR(TOYO_IOC_MAGIC, READ_STAT, 0x03)
#define CAM_READLAM _IOWR(TOYO_IOC_MAGIC, READ_LAM,  0x03)
#define CAM_READID  _IOWR(TOYO_IOC_MAGIC, READ_ID,   0x01)

#define MAX_TRANS_BYTES    128 * 1024 // 128KByte

struct camac_single{
  unsigned char naf[3];
  unsigned int data;
  unsigned int qx;
};

struct camac_block{
  unsigned char naf[3];
  unsigned int mode;
  unsigned int ch;
  void *data;
  unsigned int retlen;
};
