#include <stdio.h> 
#include <fcntl.h> 
#include <unistd.h>
#include <sys/ioctl.h>
#include <sys/time.h>
#include "ccusb.h"

#define SIZE 32*1024 //word = 64Kbyte

unsigned short blkdats[SIZE];
unsigned int blkdat[SIZE*3/4];

void print_time(struct timeval tp1, struct timeval tp2, int loop, int siz){
  long sec, usec;
  float fsec, ftime, speed;

  sec = (tp2.tv_sec) - (tp1.tv_sec);
  usec = (tp2.tv_usec) - (tp1.tv_usec);

  fsec = (float)sec + (float)usec/(float)1000000.;
  ftime = ((float)fsec)/((float)loop)*(float)1000000.;
  speed = (float)siz * (float)loop/fsec/(float)1000.0;

  printf("%d Byte  %7.2f usec  %7.4f KByte/s\n", siz, ftime, speed);
  //printf("%d %7.2f %7.2f\n", siz, ftime, speed);
}

int main(int argc, char** argv)
{
  int fd, ret = -1, i, siz, nbyte, dat;
  int n, a, f, loop;
  struct camac_block  cam_blk;
  struct timeval tp1, tp2;

  printf("Word or Long word(2/3): ");
  scanf("%d",&nbyte);

  printf("Loop Counts: ");
  scanf("%d",&loop);

  printf("N: ");
  scanf("%d",&n);

  printf("A: ");
  scanf("%d",&a);
  printf("F: ");
  scanf("%d",&f);

  if(f > 15 && f < 24) {
	  printf("data? (Hex)");
	  scanf("%x", &dat);

	  if(nbyte == 3) {
		  for(i=0; i< (SIZE*3/4); i++)
			  blkdat[i] = dat;
	  }
	  else {
		  for(i=0; i< SIZE; i++)
			  blkdats[i] = (unsigned short)dat;
		  }
  }

  printf("loop  = %d\n", loop);
  printf("nbyte = %d\n", nbyte);
  printf("n = %d\n", n);
  printf("a = %d\n", a);
  printf("f = %d\n", f);
  if(f == 16)
	  printf("dat = %d\n", dat);

  cam_blk.naf[0] = n;
  cam_blk.naf[1] = a;
  cam_blk.naf[2] = f;
  cam_blk.ch     = SIZE;
  cam_blk.mode   = BLOCK_QIGNO;

  if(nbyte == 3)
	  cam_blk.data = blkdat;
  else

	  cam_blk.data = blkdats;


  fd = open("/dev/usb/ccusb00", O_RDWR);
  printf("fd = %d\n",fd);
  
  gettimeofday(&tp1, NULL);

  if(nbyte == 3) {
	  for(i = 0; i < loop; i++)
		  ret = ioctl(fd, CAM_BLKL, &cam_blk);
	  
  } else {
	  for(i = 0; i < loop; i++) 
		  ret = ioctl(fd, CAM_BLKW, &cam_blk);
  }

  printf("ret = %d\n", ret);
  if(ret != 0) {
	  printf("ERROR: %d\n", ret);
	  return -1;
  }
  
  gettimeofday(&tp2, NULL);

  siz = cam_blk.ch * nbyte;
  print_time(tp1, tp2, loop, siz);

  if(nbyte == 2) {
	  printf("%x\n", blkdats[0]);
	  printf("%x\n", blkdats[1]);
	  printf("%x\n", blkdats[2]);
  }else {
	  printf("%x\n", blkdat[0]);
	  printf("%x\n", blkdat[1]);
	  printf("%x\n", blkdat[2]);
  }
  close(fd);
  return 0;
}
