#include <stdio.h> 
#include <fcntl.h> 
#include <unistd.h>
#include <sys/ioctl.h>
#include <sys/time.h>
#include "ccusb.h"

#define LOOP 10000

void print_time(struct timeval tp1, struct timeval tp2, int siz);

int main()
{
  int fd, ret, i, siz;
  struct camac_single cam_sing;
  struct timeval tp1, tp2;

  cam_sing.naf[0]=0x02;
  cam_sing.naf[1]=0x01;
  cam_sing.naf[2]=0x00;

  fd = open("/dev/usb/ccusb00", O_RDWR);
  printf("fd = %d\n",fd);
  
  gettimeofday(&tp1, NULL);
 
  for(i = 0; i < LOOP; i++)
    ret = ioctl(fd, CAM_WORD, &cam_sing);

  gettimeofday(&tp2, NULL);

  siz = 2;
  print_time(tp1, tp2, siz);

  close(fd);
  return 0;
}


void print_time(struct timeval tp1, struct timeval tp2, int siz){
  long sec, usec;
  float fsec, ftime, speed;

  sec = (tp2.tv_sec) - (tp1.tv_sec);
  usec = (tp2.tv_usec) - (tp1.tv_usec);

  fsec = (float)sec + (float)usec/(float)1000000.;
  ftime = ((float)fsec)/((float)LOOP)*(float)1000000.;
  speed = (float)siz * (float)LOOP/fsec/(float)1000.0;

  printf("%d Byte  %7.2f usec  %7.4f KByte/s\n", siz, ftime, speed);
  //printf("%d %7.2f %7.2f\n", siz, ftime, speed);

}
