#include <stdio.h> 
#include <fcntl.h> 
#include <unistd.h>
#include "ccusb.h"

unsigned short blkdat[100];
unsigned char  blkdatc[100];
unsigned int  blkdatl[100];

struct test_type {
  char * testname;
  int testnum;
};

struct test_type my_test [] = {
  {"CAM_INIT", CAM_INIT},
  {"CAM_SETI", CAM_SETI},
  {"CAM_CLRI", CAM_CLRI},
  {"CAM_SETLAM", CAM_SETLAM},
  {"CAM_READLAM",CAM_READLAM},
  {"CAM_CLRLAM", CAM_CLRLAM},
  {"CAM_READID", CAM_READID},
};

int main()
{
  int fd, ret, i;
  char * p;
  struct camac_single cam_sing;
  struct camac_block  cam_blk;

  /* CAMAC Control Routine Check Start*/
  printf("CAMAC Control Routine Check Start\n");

  fd = open("/dev/usb/ccusb00", O_RDWR);
  if ( fd < 0 )
    return fd;

  for(i = 0; i < (sizeof(my_test)/sizeof(my_test[0])); i++) {
      printf(" ****  %s  **** ", my_test[i].testname );
      getchar();
      ret = ioctl(fd, my_test[i].testnum, NULL);
      printf(" ret = %x\n\n", ret);
  }

  close(fd);

  /* CAMAC Control Routine Check End*/

  /* CAMAC Single Action Routine Check Start*/
  printf("CAMAC Single Action Routine Check Start\n");
  fd = open("/dev/usb/ccusb00", O_RDWR);
  if(fd < 0) 
    return fd;

  cam_sing.naf[0]=0x02;
  cam_sing.naf[1]=0x01;
  cam_sing.naf[2]=0x00;
  
  ret = ioctl(fd, CAM_WORD, &cam_sing);

  printf(" ****  Single WORD READ **** \n" );
  printf("N = %d A = %d F = %d\n",cam_sing.naf[0],cam_sing.naf[1],cam_sing.naf[2]);
  printf("ret = %x\n", ret);
  printf("dat = %x\n", cam_sing.data);
  printf("qx = %x\n", cam_sing.qx);

  getchar();

  cam_sing.naf[0]=0x02;
  cam_sing.naf[1]=0x00;
  cam_sing.naf[2]=0x10;
  cam_sing.data   =0x4321;
  
  ret = ioctl(fd, CAM_WORD, &cam_sing);

  printf(" ****  Single WORD WRITE **** \n" );
  printf("N = %d A = %d F = %d\n",cam_sing.naf[0],cam_sing.naf[1],cam_sing.naf[2]);
  printf("ret = %x\n", ret);
  printf("dat = %x\n", cam_sing.data);
  printf("qx = %x\n", cam_sing.qx);

  getchar();

  cam_sing.naf[0]=0x02;
  cam_sing.naf[1]=0x01;
  cam_sing.naf[2]=0x00;
  
  ret = ioctl(fd, CAM_LONG, &cam_sing);

  printf(" ****  Single LONG READ **** \n" );
  printf("N = %d A = %d F = %d\n",cam_sing.naf[0],cam_sing.naf[1],cam_sing.naf[2]);
  printf("ret = %x\n", ret);
  printf("dat = %x\n", cam_sing.data);
  printf("qx = %x\n", cam_sing.qx);

  getchar();

  cam_sing.naf[0]=0x02;
  cam_sing.naf[1]=0x00;
  cam_sing.naf[2]=0x10;
  cam_sing.data   =0x654321;
  
  ret = ioctl(fd, CAM_LONG, &cam_sing);

  printf(" ****  Single LONG WRITE **** \n" );
  printf("N = %d A = %d F = %d\n",cam_sing.naf[0],cam_sing.naf[1],cam_sing.naf[2]);
  printf("ret = %x\n", ret);
  printf("dat = %x\n", cam_sing.data);
  printf("qx = %x\n", cam_sing.qx);

  getchar();
  close(fd);
  /* CAMAC Single Action Routine Check End*/

  /* CAMAC Block Action Routine Check Start*/
  printf("CAMAC Block Action Routine Check Start\n");
  fd = open("/dev/usb/ccusb00", O_RDWR);
  if (fd < 0) return fd;
  
  cam_blk.naf[0] = 0x03;
  cam_blk.naf[1] = 0x00;
  cam_blk.naf[2] = 0x00;
  cam_blk.mode   = BLOCK_QIGNO;
  cam_blk.ch     = 12;
  cam_blk.data = blkdat;

  ret = ioctl(fd, CAM_BLKW, &cam_blk);

  printf(" ****  BLOCK READ Q-IGNORE **** \n" );
  printf("ret = %x\n", ret);
  printf("retlen = %d\n", cam_blk.retlen);
  for(i = 0; i < 12; i++)
    printf("data[%d] = %x\n", i, blkdat[i]);

  getchar();

  cam_blk.naf[0] = 0x03;
  cam_blk.naf[1] = 0x00;
  cam_blk.naf[2] = 0x00;
  cam_blk.mode   = BLOCK_QSTOP;
  cam_blk.ch     = 12;
  cam_blk.data = blkdat;

  ret = ioctl(fd, CAM_BLKW, &cam_blk);
  printf(" ****  BLOCK READ Q-STOP **** \n" );
  printf("ret = %x\n", ret);
  printf("retlen = %d\n", cam_blk.retlen);
  for(i = 0; i < 12; i++)
    printf("data[%d] = %x\n", i, blkdat[i]);

  getchar();

  cam_blk.naf[0] = 0x03;
  cam_blk.naf[1] = 0x00;
  cam_blk.naf[2] = 0x00;
  cam_blk.mode   = BLOCK_QREPE;
  cam_blk.ch     = 12;
  cam_blk.data = blkdat;

  ret = ioctl(fd, CAM_BLKW, &cam_blk);

  printf(" ****  BLOCK READ Q-REPEAT **** \n" );
  printf("ret = %x\n", ret);
  printf("retlen = %d\n", cam_blk.retlen);
  for(i = 0; i < 12; i++)
    printf("data[%d] = %x\n", i, blkdat[i]);

  getchar();

  cam_blk.naf[0] = 0x03;
  cam_blk.naf[1] = 0x05;
  cam_blk.naf[2] = 0x00;
  cam_blk.mode   = BLOCK_ASCAN;
  cam_blk.ch     = 100;
  cam_blk.data = blkdat;

  ret = ioctl(fd, CAM_BLKW, &cam_blk);
  printf(" ****  BLOCK READ ADDR-SCAN **** \n" );
  printf("ret = %x\n", ret);
  printf("retlen = %d\n", cam_blk.retlen);
  for(i = 0; i < cam_blk.retlen/2; i++)
    printf("data[%d] = %x\n", i, blkdat[i]);
  getchar();
  close(fd);
  /* CAMAC Block Action Routine Check Start*/
  
  cam_blk.naf[0] = 0x02;
  cam_blk.naf[1] = 0x01;
  cam_blk.naf[2] = 0x00;
  cam_blk.mode   = BLOCK_QIGNO;
  cam_blk.ch     = 20;
  cam_blk.data = blkdatc;

  fd = open("/dev/usb/ccusb00", O_RDWR);
  printf("fd = %d\n",fd);
  
  ret = ioctl(fd, CAM_BLKL, &cam_blk);

  printf("ret = %x\n", ret);
  
  p = blkdatc;
  for(i = 0; i < cam_blk.ch*3; i++){
	  //printf("data[%d] = %x\n", i, *p);
    p++;
  }


 p = blkdatc;

  for(i = 0; i < cam_blk.ch; i++){

    //blkdatl[i] = (* (unsigned int *)blkdatc ) & 0x00ffffff;
    blkdatl[i] = (* (unsigned int *)p ) & 0x00ffffff;

    p = p + 3;

  }

  for(i = 0; i < cam_blk.ch; i++){
    printf("blkdatl[%d] = %x\n", i, blkdatl[i]);

  }

  close(fd);

}
